Index: src/sans/calculator/resolution_calculator.py
===================================================================
--- src/sans/calculator/resolution_calculator.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/calculator/resolution_calculator.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -473,6 +473,5 @@
         """
         Get the variance when the slit/pinhole size is given
-        : size: list that can be one(diameter for circular)
-                or two components(lengths for rectangular)
+        : size: list that can be one(diameter for circular) or two components(lengths for rectangular)
         : distance: [z, x] where z along the incident beam, x // qx_value
         : comp: direction of the sigma; can be 'phi', 'y', 'x', and 'radial'
Index: src/sans/calculator/sans_gen.py
===================================================================
--- src/sans/calculator/sans_gen.py	(revision f468791f8ac1d2498ad79b33a2c4a0f06236dec8)
+++ src/sans/calculator/sans_gen.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -197,11 +197,7 @@
         """
         Evaluate a distribution of q-values.
-        * For 1D, a numpy array is expected as input:
-            evalDistribution(q)   
-        where q is a numpy array.
-        * For 2D, a list of numpy arrays are expected: [qx_prime,qy_prime],
-          where 1D arrays,  
-        :param qdist: ndarray of scalar q-values or list [qx,qy] 
-                    where qx,qy are 1D ndarrays 
+        * For 1D, a numpy array is expected as input: evalDistribution(q) where q is a numpy array.
+        * For 2D, a list of numpy arrays are expected: [qx_prime,qy_prime], where 1D arrays.
+        :param qdist: ndarray of scalar q-values or list [qx,qy] where qx,qy are 1D ndarrays 
         """
         if qdist.__class__.__name__ == 'list':
@@ -952,5 +948,5 @@
     def set_sldms(self, sld_mx, sld_my, sld_mz):
         """
-        Sets (|m|, m_theta, m_phi)
+        Sets (\|m\|, m_theta, m_phi)
         """
         if sld_mx.__class__.__name__ == 'float':
Index: src/sans/data_util/calcthread.py
===================================================================
--- src/sans/data_util/calcthread.py	(revision 4bae1ef3df181b863c76f4ba720691c990022cd1)
+++ src/sans/data_util/calcthread.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -33,8 +33,10 @@
     
     When defining the compute() method you need to include code which
-    allows the GUI to run.  They are as follows:
-        self.isquit()          call frequently to check for interrupts
-        self.update(kw=...)    call when the GUI could be updated
-        self.complete(kw=...)  call before exiting compute()
+    allows the GUI to run.  They are as follows: ::
+
+        self.isquit()          # call frequently to check for interrupts
+        self.update(kw=...)    # call when the GUI could be updated
+        self.complete(kw=...)  # call before exiting compute()
+
     The update() and complete() calls accept field=value keyword
     arguments which are passed to the called function.  complete()
@@ -46,14 +48,14 @@
     of the derived class.
 
-    The user of this class will call the following:
-
-        thread = Work(...,kw=...)  prepare the work thread.
-        thread.queue(...,kw=...)   queue a work unit
-        thread.requeue(...,kw=...) replace work unit on the end of queue
-        thread.reset(...,kw=...)   reset the queue to the given work unit
-        thread.stop()              clear the queue and halt
-        thread.interrupt()         halt the current work unit but continue
-        thread.ready(delay=0.)     request an update signal after delay
-        thread.isrunning()         returns true if compute() is running
+    The user of this class will call the following: ::
+
+        thread = Work(...,kw=...)  # prepare the work thread.
+        thread.queue(...,kw=...)   # queue a work unit
+        thread.requeue(...,kw=...) # replace work unit on the end of queue
+        thread.reset(...,kw=...)   # reset the queue to the given work unit
+        thread.stop()              # clear the queue and halt
+        thread.interrupt()         # halt the current work unit but continue
+        thread.ready(delay=0.)     # request an update signal after delay
+        thread.isrunning()         # returns true if compute() is running
 
     Use queue() when all work must be done.  Use requeue() when intermediate
@@ -63,5 +65,5 @@
     stop() to halt the current and pending computations (e.g., in response to
     a stop button).
-    
+
     The methods queue(), requeue() and reset() are proxies for the compute()
     method in the subclass.  Look there for a description of the arguments.
@@ -82,5 +84,5 @@
     should be implemented vary from framework to framework.
 
-    For wx, something like the following is needed:
+    For wx, something like the following is needed: ::
 
         import wx, wx.lib.newevent
Index: src/sans/data_util/registry.py
===================================================================
--- src/sans/data_util/registry.py	(revision 4bae1ef3df181b863c76f4ba720691c990022cd1)
+++ src/sans/data_util/registry.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -15,47 +15,47 @@
     Note that there may be multiple loaders for the same extension.
 
-    Example:
+    Example: ::
 
-    registry = ExtensionRegistry()
+        registry = ExtensionRegistry()
 
-    # Add an association by setting an element
-    registry['.zip'] = unzip
-    
-    # Multiple extensions for one loader
-    registry['.tgz'] = untar
-    registry['.tar.gz'] = untar
+        # Add an association by setting an element
+        registry['.zip'] = unzip
+        
+        # Multiple extensions for one loader
+        registry['.tgz'] = untar
+        registry['.tar.gz'] = untar
 
-    # Generic extensions to use after trying more specific extensions; 
-    # these will be checked after the more specific extensions fail.
-    registry['.gz'] = gunzip
+        # Generic extensions to use after trying more specific extensions; 
+        # these will be checked after the more specific extensions fail.
+        registry['.gz'] = gunzip
 
-    # Multiple loaders for one extension
-    registry['.cx'] = cx1
-    registry['.cx'] = cx2
-    registry['.cx'] = cx3
+        # Multiple loaders for one extension
+        registry['.cx'] = cx1
+        registry['.cx'] = cx2
+        registry['.cx'] = cx3
 
-    # Show registered extensions
-    print registry.extensions()
-    
-    # Can also register a format name for explicit control from caller
-    registry['cx3'] = cx3
-    print registry.formats()
+        # Show registered extensions
+        print registry.extensions()
+        
+        # Can also register a format name for explicit control from caller
+        registry['cx3'] = cx3
+        print registry.formats()
 
-    # Retrieve loaders for a file name
-    registry.lookup('hello.cx') -> [cx3,cx2,cx1]
+        # Retrieve loaders for a file name
+        registry.lookup('hello.cx') -> [cx3,cx2,cx1]
 
-    # Run loader on a filename
-    registry.load('hello.cx') ->
-        try:
+        # Run loader on a filename
+        registry.load('hello.cx') ->
+            try:
+                return cx3('hello.cx')
+            except:
+                try:
+                    return cx2('hello.cx')
+                except:
+                    return cx1('hello.cx')
+
+        # Load in a specific format ignoring extension
+        registry.load('hello.cx',format='cx3') ->
             return cx3('hello.cx')
-        except:
-            try:
-                return cx2('hello.cx')
-            except:
-                return cx1('hello.cx')
-
-    # Load in a specific format ignoring extension
-    registry.load('hello.cx',format='cx3') ->
-        return cx3('hello.cx')
     """
     def __init__(self, **kw):
Index: src/sans/fit/AbstractFitEngine.py
===================================================================
--- src/sans/fit/AbstractFitEngine.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/fit/AbstractFitEngine.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -557,6 +557,5 @@
         
         :param model: sans.models type 
-        :param : is the key of the fitArrange dictionary where model is 
-                saved as a value
+        :param id: is the key of the fitArrange dictionary where model is saved as a value
         :param pars: the list of parameters to fit 
         :param constraints: list of 
@@ -566,6 +565,5 @@
             Example:  
             we want to fit 2 model M1 and M2 both have parameters A and B.
-            constraints can be:
-             constraints = [(M1.A, M2.B+2), (M1.B= M2.A *5),...,]
+            constraints can be ``constraints = [(M1.A, M2.B+2), (M1.B= M2.A *5),...,]``
             
              
Index: src/sans/fit/ParkFitting.py
===================================================================
--- src/sans/fit/ParkFitting.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/fit/ParkFitting.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -315,7 +315,7 @@
     Set model parameter "M1"= model.name add {model.parameter.name:value}.
     
-    :note: Set_param() if used must always preceded set_model()
-         for the fit to be performed.
-    engine.set_param( model,"M1", {'A':2,'B':4})
+    ..note::
+       Set_param() if used must always preceded set_model() for the fit to be performed.
+      ``engine.set_param( model,"M1", {'A':2,'B':4})``
     
     Add model with a dictionnary of FitArrangeList{} where Uid is a key
@@ -327,5 +327,6 @@
     chisqr1, out1, cov1=engine.fit({model.parameter.name:value},qmin,qmax)
     
-    :note: {model.parameter.name:value} is ignored in fit function since 
+    ..note::
+        {model.parameter.name:value} is ignored in fit function since 
         the user should make sure to call set_param himself.
         
Index: src/sans/guiframe/CategoryManager.py
===================================================================
--- src/sans/guiframe/CategoryManager.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/guiframe/CategoryManager.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -2,12 +2,8 @@
 
 """
-
-/**
-	This software was developed by Institut Laue-Langevin as part of
-	Distributed Data Analysis of Neutron Scattering Experiments (DANSE).
-
-	Copyright 2012 Institut Laue-Langevin
-
-**/
+This software was developed by Institut Laue-Langevin as part of
+Distributed Data Analysis of Neutron Scattering Experiments (DANSE).
+
+Copyright 2012 Institut Laue-Langevin
 
 """
Index: src/sans/guiframe/local_perspectives/plotting/appearanceDialog.py
===================================================================
--- src/sans/guiframe/local_perspectives/plotting/appearanceDialog.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/guiframe/local_perspectives/plotting/appearanceDialog.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -2,11 +2,9 @@
 """
 Dialog for appearance of plot symbols, color, size etc.
-/**
-    This software was developed by Institut Laue-Langevin as part of
-    Distributed Data Analysis of Neutron Scattering Experiments (DANSE).
-
-    Copyright 2012 Institut Laue-Langevin
-
-**/
+
+This software was developed by Institut Laue-Langevin as part of
+Distributed Data Analysis of Neutron Scattering Experiments (DANSE).
+
+Copyright 2012 Institut Laue-Langevin
 """
 import wx
Index: src/sans/guiframe/local_perspectives/plotting/boxSum.py
===================================================================
--- src/sans/guiframe/local_perspectives/plotting/boxSum.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/guiframe/local_perspectives/plotting/boxSum.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -259,6 +259,5 @@
         Receive a dictionary and reset the slicer with values contained 
         in the values of the dictionary.
-        :param params: a dictionary containing name of slicer parameters and 
-            values the user assigned to the slicer.
+        :param params: a dictionary containing name of slicer parameters and values the user assigned to the slicer.
         """
         x_max = math.fabs(params["Width"] )/2
Index: src/sans/guiframe/plugin_base.py
===================================================================
--- src/sans/guiframe/plugin_base.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/guiframe/plugin_base.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -17,12 +17,13 @@
     For example, a plug-in called Foo should be place in "perspectives/Foo".
     That directory contains at least two files:
-        perspectives/Foo/__init__.py contains two lines:
-        
-            PLUGIN_ID = "Foo plug-in 1.0"
-            from Foo import *
+
+    1. perspectives/Foo/__init__.py contains two lines: ::
+        
+        PLUGIN_ID = "Foo plug-in 1.0"
+        from Foo import *
             
-        perspectives/Foo/Foo.py contains the definition of the Plugin
-        class for the Foo plug-in. The interface of that Plugin class
-        should follow the interface of the class you are looking at.
+    2. perspectives/Foo/Foo.py contains the definition of the Plugin
+       class for the Foo plug-in. The interface of that Plugin class
+       should follow the interface of the class you are looking at.
         
     See dummyapp.py for a plugin example.
Index: src/sans/models/BaseComponent.py
===================================================================
--- src/sans/models/BaseComponent.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/models/BaseComponent.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -96,36 +96,40 @@
         Evaluate a distribution of q-values.
         
-        * For 1D, a numpy array is expected as input:
+        * For 1D, a numpy array is expected as input: ::
         
             evalDistribution(q)
             
+          where q is a numpy array.
+        
+        
+        * For 2D, a list of numpy arrays are expected: [qx_prime,qy_prime],
+          where 1D arrays, ::
+        
+              qx_prime = [ qx[0], qx[1], qx[2], ....]
+
+          and ::
+
+              qy_prime = [ qy[0], qy[1], qy[2], ....] 
+        
+        Then get ::
+
+            q = numpy.sqrt(qx_prime^2+qy_prime^2)
+        
+        that is a qr in 1D array; ::
+
+            q = [q[0], q[1], q[2], ....] 
+        
+        ..note::
+          Due to 2D speed issue, no anisotropic scattering 
+          is supported for python models, thus C-models should have
+          their own evalDistribution methods.
+        
+        The method is then called the following way: ::
+        
+            evalDistribution(q)
+
         where q is a numpy array.
         
-        
-        * For 2D, a list of numpy arrays are expected: [qx_prime,qy_prime],
-          where 1D arrays,
-        
-        qx_prime = [ qx[0], qx[1], qx[2], ....]
-        and
-        qy_prime = [ qy[0], qy[1], qy[2], ....] 
-        
-        Then get
-        q = numpy.sqrt(qx_prime^2+qy_prime^2)
-        
-        that is a qr in 1D array;
-        q = [q[0], q[1], q[2], ....] 
-        
-        :Note: Due to 2D speed issue, no anisotropic scattering 
-            is supported for python models, thus C-models should have
-             their own evalDistribution methods.
-        
-        The method is then called the following way:
-        
-        evalDistribution(q)
-        where q is a numpy array.
-        
-        :param qdist: ndarray of scalar q-values or list [qx,qy] 
-                    where qx,qy are 1D ndarrays 
-        
+        :param qdist: ndarray of scalar q-values or list [qx,qy] where qx,qy are 1D ndarrays
         """
         if qdist.__class__.__name__ == 'list':
Index: src/sans/models/Constant.py
===================================================================
--- src/sans/models/Constant.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/models/Constant.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -7,7 +7,9 @@
 
 class Constant(BaseComponent):
-    """ Class that evaluates a constant model. 
-        List of default parameters:
-         value           = 1.0 
+    """
+    Class that evaluates a constant model. 
+    List of default parameters:
+    
+    * value           = 1.0 
     """
         
Index: src/sans/models/PolymerExclVolume.py
===================================================================
--- src/sans/models/PolymerExclVolume.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/models/PolymerExclVolume.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -25,9 +25,11 @@
     Refer to that file and the structure it contains
     for details of the model.
+
     List of default parameters:
-         scale           = 0.01 
-         rg              = 100.0 [A]
-         m               = 3.0 
-         background      = 0.0 [1/cm]
+    
+    * scale           = 0.01 
+    * rg              = 100.0 [A]
+    * m               = 3.0 
+    * background      = 0.0 [1/cm]
 
     """
Index: src/sans/models/PowerLawAbsModel.py
===================================================================
--- src/sans/models/PowerLawAbsModel.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/models/PowerLawAbsModel.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -1,4 +1,4 @@
 """ 
-    Provide F(x) = scale* (|x|)^(-m) + bkd
+    Provide F(x) = scale* (\|x\|)^(-m) + bkd
     Power law function as a BaseComponent model
 """
@@ -8,12 +8,13 @@
 class PowerLawAbsModel(PowerLawModel):
     """
-        Class that evaluates a absolute Power_Law model.
-        
+    Class that evaluates a absolute Power_Law model. ::
+    
         F(x) = scale* (|x|)^(-m) + bkd
-        
-        The model has three parameters: 
-            m     =  power
-            scale  =  scale factor
-            bkd    =  incoherent background
+    
+    The model has three parameters:
+
+    * m     =  power
+    * scale  =  scale factor
+    * bkd    =  incoherent background
     """
     
Index: src/sans/models/TwoPowerLawModel.py
===================================================================
--- src/sans/models/TwoPowerLawModel.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/models/TwoPowerLawModel.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -17,10 +17,12 @@
         =C*pow(qval,-1.0*power2) for q>qc
     where C=coef_A*pow(qc,-1.0*power1)/pow(qc,-1.0*power2).
+    
     List of default parameters:
-     coef_A = coefficient
-     power1 = (-) Power @ low Q
-     power2 = (-) Power @ high Q
-     qc = crossover Q-value
-     background = incoherent background
+    
+    * coef_A = coefficient
+    * power1 = (-) Power @ low Q
+    * power2 = (-) Power @ high Q
+    * qc = crossover Q-value
+    * background = incoherent background
     """
         
Index: src/sans/models/c_extension/python_wrapper/WrapperGenerator.py
===================================================================
--- src/sans/models/c_extension/python_wrapper/WrapperGenerator.py	(revision 230f479e04002ef42bafef9a227d586459b717c1)
+++ src/sans/models/c_extension/python_wrapper/WrapperGenerator.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -126,5 +126,5 @@
         buf = f.read()
         
-        self.default_list = "List of default parameters:\n"
+        self.default_list = "\n    List of default parameters:\n\n"
         #lines = string.split(buf,'\n')
         lines = buf.split('\n')
@@ -293,5 +293,5 @@
                     if len(toks2) >= 2:
                         units = toks2[1]
-                    self.default_list += "         %-15s = %s %s\n" % \
+                    self.default_list += "    * %-15s = %s %s\n" % \
                         (toks[1], val, units)
                     
Index: src/sans/models/c_extension/python_wrapper/modelTemplate.txt
===================================================================
--- src/sans/models/c_extension/python_wrapper/modelTemplate.txt	(revision 230f479e04002ef42bafef9a227d586459b717c1)
+++ src/sans/models/c_extension/python_wrapper/modelTemplate.txt	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -16,8 +16,10 @@
 Provide functionality for a C extension model
 
-:WARNING: THIS FILE WAS GENERATED BY WRAPPERGENERATOR.PY
-         DO NOT MODIFY THIS FILE, MODIFY
-            [INCLUDE_FILE]
-         AND RE-RUN THE GENERATOR SCRIPT
+.. WARNING::
+
+   THIS FILE WAS GENERATED BY WRAPPERGENERATOR.PY
+   DO NOT MODIFY THIS FILE, MODIFY
+   [INCLUDE_FILE]
+   AND RE-RUN THE GENERATOR SCRIPT
 """
 
Index: src/sans/models/qsmearing.py
===================================================================
--- src/sans/models/qsmearing.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/models/qsmearing.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -500,16 +500,14 @@
     Make fake data_x points extrapolated outside of the data_x points
     
-    : param width: array of std of q resolution
-    : param Data1D.x: Data1D.x array
-    
-    : return new_width, data_x_ext: extrapolated width array and x array
-    
-    : assumption1: data_x is ordered from lower q to higher q
-    : assumption2: len(data) = len(width)
-    : assumption3: the distance between the data points is more compact 
-            than the size of width 
-    : Todo1: Make sure that the assumptions are correct for Data1D
-    : Todo2: This fixes the edge problem in Qsmearer but still needs to make 
-            smearer interface 
+    :param width: array of std of q resolution
+    :param Data1D.x: Data1D.x array
+    
+    :return new_width, data_x_ext: extrapolated width array and x array
+    
+    :assumption1: data_x is ordered from lower q to higher q
+    :assumption2: len(data) = len(width)
+    :assumption3: the distance between the data points is more compact than the size of width 
+    :Todo1: Make sure that the assumptions are correct for Data1D
+    :Todo2: This fixes the edge problem in Qsmearer but still needs to make smearer interface 
     """
     # Length of the width
Index: src/sans/perspectives/calculator/data_operator.py
===================================================================
--- src/sans/perspectives/calculator/data_operator.py	(revision f468791f8ac1d2498ad79b33a2c4a0f06236dec8)
+++ src/sans/perspectives/calculator/data_operator.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -29,7 +29,4 @@
 class DataOperPanel(wx.ScrolledWindow):
     """
-    :param data: when not empty the class can 
-                same information into a data object
-        and post event containing the changed data object to some other frame
     """
     def __init__(self, parent, *args, **kwds):
Index: src/sans/perspectives/calculator/kiessig_calculator_panel.py
===================================================================
--- src/sans/perspectives/calculator/kiessig_calculator_panel.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/perspectives/calculator/kiessig_calculator_panel.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -1,4 +1,4 @@
 """
-   This software was developed by the University of Tennessee as part of the
+This software was developed by the University of Tennessee as part of the
 Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
 project funded by the US National Science Foundation. 
Index: src/sans/perspectives/calculator/resolution_calculator_panel.py
===================================================================
--- src/sans/perspectives/calculator/resolution_calculator_panel.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/perspectives/calculator/resolution_calculator_panel.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -1,4 +1,4 @@
 """
-   This software was developed by the University of Tennessee as part of the
+This software was developed by the University of Tennessee as part of the
 Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
 project funded by the US National Science Foundation. 
Index: src/sans/perspectives/calculator/slit_length_calculator_panel.py
===================================================================
--- src/sans/perspectives/calculator/slit_length_calculator_panel.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/perspectives/calculator/slit_length_calculator_panel.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -1,4 +1,4 @@
 """
-   This software was developed by the University of Tennessee as part of the
+This software was developed by the University of Tennessee as part of the
 Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
 project funded by the US National Science Foundation. 
Index: src/sans/perspectives/invariant/invariant_state.py
===================================================================
--- src/sans/perspectives/invariant/invariant_state.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/perspectives/invariant/invariant_state.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -252,6 +252,5 @@
         : param file: file to write to
         : param doc: XML document object [optional]
-        : param entry_node: XML node within the XML document at which 
-            we will append the data [optional]   
+        : param entry_node: XML node within the XML document at which we will append the data [optional]
         """
         from xml.dom.minidom import getDOMImplementation
Index: src/sans/plottools/SimpleFont.py
===================================================================
--- src/sans/plottools/SimpleFont.py	(revision a9d5684a6f797bf085c13ace14b5b02de34989db)
+++ src/sans/plottools/SimpleFont.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -1,12 +1,8 @@
 
 """
-/**
-	This software was developed by Institut Laue-Langevin as part of
-	Distributed Data Analysis of Neutron Scattering Experiments (DANSE).
+This software was developed by Institut Laue-Langevin as part of
+Distributed Data Analysis of Neutron Scattering Experiments (DANSE).
 
-	Copyright 2012 Institut Laue-Langevin
-
-**/
-
+Copyright 2012 Institut Laue-Langevin
 """
 
Index: src/sans/plottools/plottables.py
===================================================================
--- src/sans/plottools/plottables.py	(revision a9d5684a6f797bf085c13ace14b5b02de34989db)
+++ src/sans/plottools/plottables.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -343,23 +343,25 @@
     A transform has a number of attributes.
     
-    name: user visible name for the transform.  This will
-        appear in the context menu for the axis and the transform
-        menu for the graph.
-        
-    type: operational axis.  This determines whether the
-        transform should appear on x,y or z axis context
-        menus, or if it should appear in the context menu for
-        the graph.
-        
-    inventory: (not implemented) 
-        a dictionary of user settable parameter names and
-        their associated types.  These should appear as keyword
-        arguments to the transform call.  For example, Fresnel
-        reflectivity requires the substrate density:
-             { 'rho': type.Value(10e-6/units.angstrom**2) }
-             
-        Supply reasonable defaults in the callback so that
-        limited plotting clients work even though they cannot
-        set the inventory.
+    name
+      user visible name for the transform.  This will
+      appear in the context menu for the axis and the transform
+      menu for the graph.
+        
+    type
+      operational axis.  This determines whether the
+      transform should appear on x,y or z axis context
+      menus, or if it should appear in the context menu for
+      the graph.
+        
+    inventory
+      (not implemented) 
+      a dictionary of user settable parameter names and
+      their associated types.  These should appear as keyword
+      arguments to the transform call.  For example, Fresnel
+      reflectivity requires the substrate density:
+      ``{ 'rho': type.Value(10e-6/units.angstrom**2) }``       
+      Supply reasonable defaults in the callback so that
+      limited plotting clients work even though they cannot
+      set the inventory.
         
     """
Index: src/sans/pr/invertor.py
===================================================================
--- src/sans/pr/invertor.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ src/sans/pr/invertor.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -61,14 +61,17 @@
     
     In the following i refers to the ith base function coefficient.
-    The matrix has its entries j in its first Npts rows set to
+    The matrix has its entries j in its first Npts rows set to ::
+
         A[j][i] = (Fourier transformed base function for point j)
         
     We them choose a number of r-points, n_r, to evaluate the second
     derivative of P(r) at. This is used as our regularization term.
-    For a vector r of length n_r, the following n_r rows are set to
+    For a vector r of length n_r, the following n_r rows are set to ::
+
         A[j+Npts][i] = (2nd derivative of P(r), d**2(P(r))/d(r)**2,
         evaluated at r[j])
         
-    The vector b has its first Npts entries set to
+    The vector b has its first Npts entries set to ::
+
         b[j] = (I(q) observed for point j)
         
@@ -79,8 +82,9 @@
     
     Methods inherited from Cinvertor:
-    - get_peaks(pars): returns the number of P(r) peaks
-    - oscillations(pars): returns the oscillation parameters for the output P(r)
-    - get_positive(pars): returns the fraction of P(r) that is above zero
-    - get_pos_err(pars): returns the fraction of P(r) that is 1-sigma above zero
+
+    * ``get_peaks(pars)``: returns the number of P(r) peaks
+    * ``oscillations(pars)``: returns the oscillation parameters for the output P(r)
+    * ``get_positive(pars)``: returns the fraction of P(r) that is above zero
+    * ``get_pos_err(pars)``: returns the fraction of P(r) that is 1-sigma above zero
     """
     ## Chisqr of the last computation
@@ -252,13 +256,16 @@
         
         In the following i refers to the ith base function coefficient.
-        The matrix has its entries j in its first Npts rows set to
+        The matrix has its entries j in its first Npts rows set to ::
+
             A[i][j] = (Fourier transformed base function for point j)
             
         We them choose a number of r-points, n_r, to evaluate the second
         derivative of P(r) at. This is used as our regularization term.
-        For a vector r of length n_r, the following n_r rows are set to
+        For a vector r of length n_r, the following n_r rows are set to ::
+
             A[i+Npts][j] = (2nd derivative of P(r), d**2(P(r))/d(r)**2, evaluated at r[j])
             
-        The vector b has its first Npts entries set to
+        The vector b has its first Npts entries set to ::
+
             b[j] = (I(q) observed for point j)
             
@@ -271,5 +278,4 @@
         :param nr: number of r points to evaluate the 2nd derivative at for the reg. term.
         :return: c_out, c_cov - the coefficients with covariance matrix
-        
         """
         # Reset the background value before proceeding
@@ -395,14 +401,17 @@
         
         In the following i refers to the ith base function coefficient.
-        The matrix has its entries j in its first Npts rows set to
+        The matrix has its entries j in its first Npts rows set to ::
+
             A[i][j] = (Fourier transformed base function for point j)
             
         We them choose a number of r-points, n_r, to evaluate the second
         derivative of P(r) at. This is used as our regularization term.
-        For a vector r of length n_r, the following n_r rows are set to
+        For a vector r of length n_r, the following n_r rows are set to ::
+
             A[i+Npts][j] = (2nd derivative of P(r), d**2(P(r))/d(r)**2,
             evaluated at r[j])
             
-        The vector b has its first Npts entries set to
+        The vector b has its first Npts entries set to ::
+
             b[j] = (I(q) observed for point j)
             
@@ -413,6 +422,5 @@
         
         :param nfunc: number of base functions to use.
-        :param nr: number of r points to evaluate the 2nd derivative at
-            for the reg. term.
+        :param nr: number of r points to evaluate the 2nd derivative at for the reg. term.
 
         If the result does not allow us to compute the covariance matrix,
@@ -512,7 +520,7 @@
         number of terms
         
-        :param isquit_func: reference to thread function to call to
-                            check whether the computation needs to
-                            be stopped.
+        :param isquit_func:
+          reference to thread function to call to check whether the computation needs to
+          be stopped.
         
         :return: number of terms, alpha, message
Index: test/sansmodels/test/utest_newstylemodels.py
===================================================================
--- test/sansmodels/test/utest_newstylemodels.py	(revision 5777106e8a4a0a62fe2ee0fbaf7c0aa19c0bb92b)
+++ test/sansmodels/test/utest_newstylemodels.py	(revision 51f1460382d03af9a969830094572115961c474d)
@@ -63,29 +63,4 @@
             print self.model.other
         self.assertRaises(AttributeError, setother)
-        
-class TestAdaptor(unittest.TestCase):
-    """
-        Testing C++ Cylinder model
-    """
-    def setUp(self):
-        from sans.models.NewCylinderModel import CylinderModel
-        self.model = CylinderModel()
-        
-        
-    def test_setparam(self):
-        self.model.setParam("length", 151.0)
-        self.assertEquals(self.model.getParam("length"), 151.0)
-        
-        
-        
-        print self.model(0.001)
-        print self.model.parameters['length']
-        self.model.setParam("length", 250.0)
-        self.assertEquals(self.model.getParam("length"), 250.0)
-        
-        print self.model.parameters['length']
-        print self.model(0.001)
-        
-    
   
 if __name__ == '__main__':